-- Workqueue support

-- Does not expect to run in multiple threads

function Considerater:InitWorkQueue()
  self.workqueue = {}
end

function Considerater:QueueWork(name, f)
  self.workqueue[name] = f
  ConsideraterUpdateFrame:Show()
end

function Considerater:UnqueueWork(name)
  self.workqueue[name] = nil
end

function Considerater:DoWorkQueue()
  if self.workqueue then
    local name, f = next(self.workqueue)
    if f then
      self.workqueue[name] = nil
      f()
      if next(self.workqueue) then
        ConsideraterUpdateFrame:Show()
      end
    end
  end
end

