-- Considerater
--
-- Default Profiles for different classes

Considerater.defaultProfileTable = {
  ["Druid"] = {
    ["Resto PvE"] = {
      ["SPI"] = 8,
      ["INT"] = 6,
      ["STA"] = 4,
      ["SPELL_DMG"] = 18.8,
      ["MANA_REG"] = 24,
    },
    ["Cat DPS"] = {
      ["STR"] = 2.266,
      ["AGI"] = 2.812,
      ["MELEE_HASTE_RATING"] = 1.443,
      ["MELEE_CRIT_RATING"] = 1.676,
      ["MELEE_HIT_RATING"] = 2.07,
      ["AP"] = 1,
      ["FERAL_AP"] = 1,
      ["ARMOR_PENETRATION_RATING"] = 2.247,
      ["EXPERTISE_RATING"] = 2.096,
    },
    ["Bear Tank"] = {
      ["STA"] = 4.33,
      ["AGI"] = 6.79,
      ["ARMOR"] = 0.59,
      ["DEFENSE_RATING"] = 2.79,
      ["DODGE_RATING"] = 4.43,
      ["EXPERTISE_RATING"] = 1.69,
    },
    ["Balance DPS"] = {
      ["MELEE_CRIT_RATING"] = 15,
      ["MELEE_HIT_RATING"] = 10,
      ["INT"] = 6,
      ["STA"] = 4,
      ["SPELL_DMG"] = 18.8,
      ["MANA_REG"] = 10,
    },
  },
  ["Death Knight"] = {
    ["DPS"] = {
      ["STR"] = 4,
      ["STA"] = 1,
      ["AGI"] = 2.5,
      ["MELEE_HASTE_RATING"] = 1,
      ["MELEE_CRIT_RATING"] = 4,
      ["MELEE_HIT_RATING"] = 3,
      ["AP"] = 1.8,
      ["ARMOR_PENETRATION_RATING"] = 3.5,
      ["EXPERTISE_RATING"] = 3,
      ["DPS"] = 25,
    },
    ["Tank"] = {
      ["STR"] = 15,
      ["STA"] = 17.7,
      ["AGI"] = 17,
      ["ARMOR"] = 0.9,
      ["ARMOR_BONUS"] = 0.9,
      ["DEFENSE_RATING"] = 20.7,
      ["DODGE_RATING"] = 22.7,
      ["EXPERTISE_RATING"] = 15,
      ["PARRY_RATING"] = 18.2,
      ["ARMOR_PENETRATION_RATING"] = 1,
      ["DPS"] = 25,
      ["AP"] = 6.7,
      ["MELEE_CRIT_RATING"] = 6.7,
      ["MELEE_HIT_RATING"] = 10,
      ["MELEE_HASTE_RATING"] = 10,
    },
  },
  ["Hunter"] = {
    ["DPS"] = {
      ["AGI"] = 7,
      ["INT"] = 3.8,
      ["MELEE_HASTE_RATING"] = 4.8,
      ["MELEE_CRIT_RATING"] = 5.8,
      ["MELEE_HIT_RATING"] = 7.8,
      ["AP"] = 7.5,
      ["ARMOR_PENETRATION_RATING"] = 2.5,
      ["DPS"] = 25,
      ["MANA_REG"] = 2.5,
    },
  },
  ["Mage"] = {
    ["Fire PvE"] = {
      ["STA"] = 3.4,
      ["INT"] = 5.3,
      ["MELEE_HASTE_RATING"] = 20.7,
      ["MELEE_CRIT_RATING"] = 16.5,
      ["MELEE_HIT_RATING"] = 25,
      ["SPELL_DMG"] = 24.3,
    },
    ["Frost PvE"] = {
      ["STA"] = 3.4,
      ["INT"] = 5.3,
      ["MELEE_HASTE_RATING"] = 20.7,
      ["MELEE_CRIT_RATING"] = 12.5,
      ["MELEE_HIT_RATING"] = 25,
      ["SPELL_DMG"] = 24.3,
    },
  },
  ["Paladin"] = {
    ["Holy PvE"] = {
      ["STA"] = 4,
      ["INT"] = 9,
      ["MELEE_CRIT_RATING"] = 9,
      ["MELEE_HASTE_RATING"] = 4,
      ["ARMOR"] = 0.4,
      ["ARMOR_BONUS"] = 0.4,
      ["MANA_REG"] = 18,
      ["SPELL_DMG"] = 9.1,
    },
    ["Prot PvE"] = {
      ["STA"] = 24.6,
      ["AGI"] = 21,
      ["INT"] = 6.3,
      ["ARMOR"] = 2,
      ["ARMOR_BONUS"] = 2,
      ["DEFENSE_RATING"] = 25,
      ["DODGE_RATING"] = 24.5,
      ["BLOCK_VALUE"] = 6.3,
      ["BLOCK_RATING"] = 16.5,
      ["PARRY_RATING"] = 24,
      ["MELEE_HIT_RATING"] = 5,
      ["EXPERTISE_RATING"] = 6.3,
      ["SPELL_DMG"] = 10,
    },
    ["Ret PvE"] = {
      ["DPS"] = 25,
      ["STR"] = 6.1,
      ["MELEE_HIT_RATING"] = 6.0,
      ["EXPERTISE_RATING"] = 3.8,
      ["MELEE_CRIT_RATING"] = 3.6,
      ["AGI"] = 3.4,
      ["AP"] = 3.2,
      ["INT"] = 2.1,
      ["STA"] = 2,
    }
  },
  ["Priest"] = {
    ["Disc PvP"] = {
      ["STA"] = 14.5,
      ["INT"] = 7,
      ["SPI"] = 1.5,
      ["MELEE_HASTE_RATING"] = 8.1,
      ["MELEE_CRIT_RATING"] = 1.7,
      ["RESILIENCE_RATING"] = 23.2,
      ["MANA_REG"] = 10,
      ["SPELL_DMG"] = 1.2,
    },
    ["Holy DS PvE"] = {
      ["INT"] = 12.25,
      ["SPI"] = 15.5,
      ["MELEE_HASTE_RATING"] = 0.75,
      ["MELEE_CRIT_RATING"] = 1.5,
      ["SPELL_DMG"] = 11.25,
      ["MANA_REG"] = 25,
    },
    ["Holy CoH PvE"] = {
      ["INT"] = 13.25,
      ["SPI"] = 16.5,
      ["MELEE_HASTE_RATING"] = 2.5,
      ["MELEE_CRIT_RATING"] = 1.5,
      ["SPELL_DMG"] = 12.75,
      ["MANA_REG"] = 25,
    },
    ["Shadow (+hit) PvE"] = {
      ["INT"] = 1.00,
      ["SPI"] = 2.30,
      ["MELEE_HASTE_RATING"] = 18,
      ["MELEE_CRIT_RATING"] = 3.4,
      ["MELEE_HIT_RATING"] = 25,
      ["SPELL_DMG"] = 21,
    },
    ["Shadow PvE"] = {
      ["INT"] = 1.25,
      ["SPI"] = 2.75,
      ["MELEE_HASTE_RATING"] = 24.5,
      ["MELEE_CRIT_RATING"] = 4.3,
      ["SPELL_DMG"] = 25,
    },
    ["Shadow PvP"] = {
      ["STA"] = 18.75,
      ["INT"] = 0.9,
      ["MELEE_HASTE_RATING"] = 10.1,
      ["MELEE_CRIT_RATING"] = 2.1,
      ["SPELL_DMG"] = 12.5,
      ["MANA_REG"] = 2.5,
      ["RESILIENCE_RATING"] = 25,
    },
  },
  ["Rogue"] = {
    ["PvE"] = {
      ["AGI"] = 25,
      ["AP"] = 10,
      ["STA"] = 2,
      ["MELEE_HASTE_RATING"] = 20,
      ["MELEE_CRIT_RATING"] = 18,
      ["MELEE_HIT_RATING"] = 22,
      ["ARMOR_PENETRATION_RATING"] = 21,
      ["EXPERTISE_RATING"] = 25,
      ["DPS"] = 20,
    },
  },
  ["Shaman"] = {
    ["Elemental"] = {
      ["INT"] = 6,
      ["MELEE_HASTE_RATING"] = 15.5,
      ["MELEE_CRIT_RATING"] = 19.5,
      ["MELEE_HIT_RATING"] = 1.5,
      ["MANA_REG"] = 7.5,
      ["SPELL_DMG"] = 25,
    },
    ["Enhancement"] = {
      ["STR"] = 2.75,
      ["AGI"] = 4.6,
      ["MELEE_HASTE_RATING"] = 4.25,
      ["MELEE_CRIT_RATING"] = 4.8,
      ["MELEE_HIT_RATING"] = 4.2,
      ["AP"] = 2.5,
      ["ARMOR_PENETRATION_RATING"] = 5,
      ["EXPERTISE_RATING"] = 7,
      ["DPS"] = 25,
    },
    ["Restoration"] = {
      ["STA"] = 1,
      ["INT"] = 5.5,
      ["MELEE_HASTE_RATING"] = 2.5,
      ["MELEE_CRIT_RATING"] = 1.5,
      ["MANA_REG"] = 25,
      ["SPELL_DMG"] = 11.3,
    },
  },
  ["Warlock"] = {
    ["Affliction"] = {
      ["STA"] = 8,
      ["INT"] = 2.5,
      ["MELEE_HASTE_RATING"] = 8.3,
      ["MELEE_CRIT_RATING"] = 6,
      ["MELEE_HIT_RATING"] = 12.5,
      ["SPELL_DMG"] = 25,
    },
    ["Demonology"] = {
      ["STA"] = 8,
      ["INT"] = 2.5,
      ["MELEE_HASTE_RATING"] = 13.5,
      ["MELEE_CRIT_RATING"] = 8.3,
      ["MELEE_HIT_RATING"] = 12.5,
      ["SPELL_DMG"] = 25,
      ["SPI"] = 13,
    },
    ["Destruction"] = {
      ["STA"] = 8,
      ["INT"] = 2.5,
      ["MELEE_HASTE_RATING"] = 13,
      ["MELEE_CRIT_RATING"] = 8,
      ["MELEE_HIT_RATING"] = 12.5,
      ["SPELL_DMG"] = 25,
      ["SPI"] = 8,
    },
    ["Affliction, Pre-raid"] = {
      ["STA"] = 8,
      ["INT"] = 2.5,
      ["MELEE_HASTE_RATING"] = 8.3,
      ["MELEE_CRIT_RATING"] = 6,
      ["MELEE_HIT_RATING"] = 25,
      ["SPELL_DMG"] = 25,
    },
    ["Demonology, Pre-raid"] = {
      ["STA"] = 8,
      ["INT"] = 2.5,
      ["MELEE_HASTE_RATING"] = 13.5,
      ["MELEE_CRIT_RATING"] = 8.3,
      ["MELEE_HIT_RATING"] = 25,
      ["SPELL_DMG"] = 25,
      ["SPI"] = 13,
    },
    ["Destruction, Pre-raid"] = {
      ["STA"] = 8,
      ["INT"] = 2.5,
      ["MELEE_HASTE_RATING"] = 13,
      ["MELEE_CRIT_RATING"] = 8,
      ["MELEE_HIT_RATING"] = 25,
      ["SPELL_DMG"] = 25,
      ["SPI"] = 8,
    },
  },
  ["Warrior"] = {
    ["DPS"] = {
      ["STR"] = 4,
      ["STA"] = 0.75,
      ["AGI"] = 3.75,
      ["MELEE_HASTE_RATING"] = 4.5,
      ["MELEE_CRIT_RATING"] = 5,
      ["MELEE_HIT_RATING"] = 3.75,
      ["AP"] = 1.75,
      ["ARMOR_PENETRATION_RATING"] = 3.5,
      ["EXPERTISE_RATING"] = 3.75,
      ["DPS"] = 25,
    },
    ["Tank"] = {
      ["STR"] = 10,
      ["STA"] = 20,
      ["AGI"] = 16,
      ["ARMOR"] = 1.5,
      ["ARMOR_BONUS"] = 1.5,
      ["DEFENSE_RATING"] = 25,
      ["DODGE_RATING"] = 23.5,
      ["BLOCK_VALUE"] = 11,
      ["BLOCK_RATING"] = 3.75,
      ["PARRY_RATING"] = 22,
      ["MELEE_HIT_RATING"] = 8,
      ["EXPERTISE_RATING"] = 15, 
    },
  },
}

